module Functor
  def make(**kwargs)
    base = self
    Module.new do
      kwargs.each do |name, value|
        define_method name do
          value
        end
      end
      include base
    end
  end
end

module HasShortCode
  extend Functor
  def short_url
    "https://example.com/#{ prefix }/#{ id }"
  end
end

module HasShortCode
  module InitMethods
    def has_short_code(prefix:)
      send :include, HasShortCode.make(prefix: prefix)
    end
  end
end

# short_url
class O
  extend HasShortCode::InitMethods
  has_short_code prefix: 'post'
  attr_accessor :id
  def initialize(id)
    @id = id
  end
end

o = O.new 19
p o.short_url
